<template>
  <v-row class="pt-2">
    <v-col>
      <v-card outlined flat class="panel">
        <v-card-title>
          <v-row class="pl-5 pr-5 ma-0">
            <v-col sm="3">
              <client-select
                @change="fetchData"
                v-model="clientId"
                hint="Zgjidhni klientin për të parë mandatet"
                persistent-hint
              />
            </v-col>
            <v-col sm="2">
              <v-select
                class="mt-2"
                v-model="documentType"
                label="Tipi i dokumentit"
                outlined
                dense
                :items="documentTypes"
                clearable
                @change="fetchData"
              />
            </v-col>
            <v-spacer />
            <v-col cols="4" class="ml-5">
              <v-text-field
                v-model="search"
                prepend-inner-icon="search"
                label="Kërko"
                single-line
                hide-details
                clearable
                @input="fetchData"
              />
            </v-col>
          </v-row>
        </v-card-title>
        <v-data-table
          dense
          :headers="headers"
          :items="data"
          :loading="loading"
          :options.sync="pagination"
          :server-items-length="totalRecords"
          outlined
          show-select
          @item-selected="rowSelected"
          v-model="selected"
        >
          <template v-slot:[`item.status_id`]="row">
            <v-chip
              class="ma-2 status"
              :color="statusColor(row.item.status_id)"
              small
            >
              {{ statusName(row.item.status_id) }}
            </v-chip>
          </template>
          <template v-slot:[`item.actions`]="row">
            <receipt-list :receipt-id="row.item.id" type="clients" />
            <reconciliation :receipt-id="row.item.id" type="clients" />
            <f-edit-btn @click="editReceipt(row.item)" :receipt="receipt" />
            <f-delete-btn
              @click="deleteReceipt(row.item)"
              :receipt="receipt"
              :disabled="row.item.status_id === 16 || row.item.status_id === 1"
            />
          </template>
        </v-data-table>
        <create-client-receipt
          @close="showCreateClientReceiptModal = false"
          @refresh="fetchData()"
          v-model="showCreateClientReceiptModal"
        />
        <edit-client-receipt
          v-if="showEditClientReceiptModal"
          v-model="showEditClientReceiptModal"
          :receipt="receipt"
          @refresh="fetchData()"
          @close="showEditClientReceiptModal = false"
        />
        <delete-receipt
          v-model="showDeleteClientReceiptModal"
          @refresh="fetchData()"
          @close="showDeleteClientReceiptModal = false"
          :receipt="receipt"
        />
        <portal to="destination">
          <div class="portal-wrapper">
            <h3>
              Mandati i Arketimit
            </h3>
          </div>
        </portal>
        <portal to="cto-topmenu">
          <div style="display: flex; align-content: center;">
            <download-excel
              class="export-button ma-2"
              :data="dataToExport"
              :fields="exportFields"
              worksheet="Mandati_i_Arketimit"
              :name="`Mandati_i_Arketimit_${todayDate}`"
            >
              Eksporto<v-icon right dark small>mdi-file-download</v-icon>
            </download-excel>
            <f-action-btn
              icon="add"
              @click="showCreateClientReceiptModal = true"
            />
          </div>
        </portal>
      </v-card>
    </v-col>
  </v-row>
</template>

<script lang="ts">
import { Component, Mixins } from 'vue-property-decorator'
import Table from '../../../plugins/table'
import api from '../../../plugins/api'
import FEditBtn from '@/components/buttons/FEditBtn.vue'
import FDeleteBtn from '@/components/buttons/FDeleteBtn.vue'
import FActionBtn from '@/components/buttons/FActionBtn.vue'
import ClientSelect from '@/components/general/ClientSelect.vue'
import CreateClientReceipt from '@/views/Receipts/components/CreateClientReceipt.vue'
import EditClientReceipt from '@/views/Receipts/components/EditClientReceipt.vue'
import DeleteReceipt from '@/views/Receipts/components/DeleteReceipt.vue'

const datatableHeader = [
  { text: 'Id', value: 'id' },
  { text: 'Përdoruesi', value: 'full_name' },
  {
    text: 'Monedha',
    value: 'currency',
    sortable: false,
  },
  { text: 'Shënime', value: 'notes', sortable: false },
  { text: 'Data', value: 'date' },
  {
    text: 'Statusi',
    value: 'status_id',
    sortable: false,
  },
  {
    text: 'Veprimet',
    value: 'actions',
    sortable: false,
  },
]

const exelHeaders = {
  Id: 'id',
  Përdoruesi: 'full_name',
  Vlera: 'value',
  'Vlera e mbetur': 'unreconciled_value',
  Monedha: 'receipt.currency',
  Shënime: 'notes',
  Data: 'date',
}

@Component({
  components: {
    DeleteReceipt,
    EditClientReceipt,
    CreateClientReceipt,
    ClientSelect,
    FActionBtn,
    FDeleteBtn,
    FEditBtn,
  },
})
export default class ClientReceipts extends Mixins(Table) {
  headers = datatableHeader
  showCreateClientReceiptModal?: boolean = false
  showEditClientReceiptModal?: boolean = false
  showDeleteClientReceiptModal?: boolean = false
  receipt?: object = {}
  selected = []
  statusId?: number | null = null
  documentType?: string | null = null
  statuses: Array<object> = [
    { status_id: 15, status: 'Draft' },
    { status_id: 16, status: 'Confirmed' },
    { status_id: 1, status: 'Reconciled' },
  ]
  documentTypes: Array<string> = ['MA', 'MAB', 'MAC']
  filters: Array<any> = [
    {
      prop: 'search',
      value: '',
    },
  ]
  clientId?: number | null = null
  exportFields = exelHeaders
  todayDate = new Date().toLocaleDateString('en-gb')

  statusColor(statusId: number) {
    const color = {
      1: 'orange',
      15: '#1867c0',
      16: '#9acb34',
    }
    return color[statusId]
  }

  statusName(statusId: number) {
    const name = {
      1: 'Rekonsiluar',
      15: 'Draft',
      16: 'Konfirmuar',
    }
    return name[statusId]
  }

  prepareQueryParams() {
    const queryParams: any = {}

    if (this.statusId) {
      queryParams['status_id'] = this.statusId
    }

    if (this.documentType) {
      queryParams['document_type'] = this.documentType
    }

    this.filters.forEach(filter => {
      if (filter.prop === 'search' && filter.value.length > 0) {
        const searchString = encodeURI(filter.value)
        queryParams.qs = `${searchString}`
      }
    })
    return queryParams
  }

  fetchData() {
    const query = this.prepareQuery(this.prepareQueryParams())
    this.loading = true
    api()
      .get(`api/crm/clients/${this.clientId}/receipts/${query}`)
      .then(response => {
        this.data = response.data.data
        this.totalRecords = response.data.meta.total
      })
      .finally(() => {
        this.loading = false
      })
  }

  editReceipt(receipt: any) {
    this.showEditClientReceiptModal = true
    this.receipt = receipt
  }

  deleteReceipt(receipt: any) {
    this.showDeleteClientReceiptModal = true
    this.receipt = receipt
  }
  rowSelected() {
    // this.$nextTick(() => {
    //   console.log(this.selected)
    // })
  }
  get dataToExport() {
    return this.selected.length != 0 ? this.selected : this.data
  }
}
</script>

<style scoped>
.status {
  color: #fff;
  width: 100px;
  display: flex;
  justify-content: center;
}
.export-button {
  background-color: #30488b;
  text-transform: uppercase;
  font-size: 80%;
  font-weight: 500;
  color: white;
  padding: 5px 10px;
  border-radius: 5px;
  cursor: pointer;
}
.export-button:hover {
  background-color: rgb(48, 72, 139, 0.95);
}
</style>
